library mutate.src.mutation;

import 'package:dom/dom.dart';

/// A mutation record for DOM.
class Mutation<T extends Node> {
  /// Nodes that should be added as child nodes in [target].
  final Iterable<T> added;

  /// Nodes that should be removed as child nodes from [target].
  final Iterable<T> removed;

  /// The parent node.
  final T parent;

  /// If non-null, [added] should occur after this node.
  final T previous;

  const Mutation(
      this.parent, {
      this.previous,
      this.added: const [],
      this.removed: const []});
}
